\section{Varieties, clones, and relational structures}

Before we get to prove the results of this paper, we would like to recall
another constructions of a~class-size lattices that is equivalent to the
lattice of interpretability types of varieties. That is the lattice of
(homomorphism classes of) clones ordered by an existence of a~clone
homomorphism: We start with a~preorder on clones defined by the existence of a~clone
homomorphism between the two clones, and follow by factoring out the
homomorphically equivalent clones.  The equivalence of the two construction is
implicitly given by Birkhoff's theorem.
There is also a~third construction that lacks being completely equivalent to
the two: taking relational structures and pp-interpretability between them.
Those are connected to clones by the Galois correspondence between relations
and function clones on a~fixed (finite) set. Even though this construction
of the lattice of interpretability types lacks to be equivalent in general, we
will often describe some function clones as clones of polymorphisms of
a~relational structure.

\subsection{Function clones} \label{sec:2.1}
A~function clone (or just a clone) is a~set of operations $\clo A$ on a~fixed
set $A$ that contains projections and is closed under composition. We will
always use the same letter in italic font to denote the underlying set of the
clone.
By a~\emph{clone homomorphism} from a~function clone $\clo A$ to a~function
clone $\clo B$ we mean a~mapping $\xi\colon \clo A \to \clo B$ that preserves
composition and projections.

The correspondence between clones and varieties is given by the following: Any
clone $\clo A$ can be naturally understood as an~algebra $\al A = (A, (f)_{f\in
\clo A})$ having the signature $\clo A$; the corresponding variety is then the
variety generated by $\al A$. The same variety can be also understood as the
variety of all actions of $\clo A$ on sets (each action of $\clo A$ gives an
algebra in $\HSP \al A$). We will call this variety \emph{the variety of
actions of $\clo A$}.
For the other way, to obtain a~clone corresponding to a~variety $\var V$ we
take the clone of term functions of its countably-generated free algebra $\clo
F$, or in fact a~clone of term functions of any generator of $\var V$ (any two
such clones are isomorphic). When we refer to a~\emph{clone of a~variety} we
mean the function clone $\clo F$ above.

\subsection{Relational structures and pp-interpretations}
We say that a~relation $R$ is \emph{pp-definable} in the structure $\rel B$ if
there is a~primitive positive formula (using only conjunction and existential
quantifiers) $\psi$ such that $(b_1,\dots,b_k) \in R$ if and only if $\rel B
\models \psi(b_1,\dots,b_n)$, and we say that a~structure $\rel A$ is
\emph{pp-interpretable} in $\rel B$ if there is a~pp-definable relation $R$ and
a~surjective mapping $f\colon R \to A$ such that the kernel of $f$ and the
relations $f^{-1}(S^{\rel A})$, where $S$ is a~relation $S$ of $\rel A$, are
pp-definable in $\rel B$.

The following relation between pp-interpretations and clone homomorphisms for
finite underlying sets is a~consequence of the Galois correspondence between
function clones and pp-closed systems of relations (see e.g.\ \cite{geiger68})
and Birkhoff's HSP theorem.

\begin{theorem} \label{thm:structures-clones}
Let $\rel A$, $\rel B$ be finite relational structures and $\clo A$\!, $\clo B$,
respective, their polymorphism clones.
Then the following are equivalent.
\begin{itemize}
  \item[(i)] $\rel B$ is pp-interpretable in $\rel A$.
  \item[(ii)] There exists a~clone homomorphism from $\clo A$ into $\clo B$.
  \qed
\end{itemize}
\end{theorem}

For infinite structures, there are a~few issues that can be resolved by
restricting to countable $\omega$-categorical structures and considering
uniformly continuous clone homomorphisms, or relaxing a~definition of relational
structure to allow infinitary relations and allow infinite `pp-definitions' (see
\cite{bodirsky.pinsker15} and \cite{romov77}).  Nevertheless, the implication
(i) $\to$ (ii) is valid in general, i.e., if the structures $\rel A$ and $\rel
B$ are infinite and not necessarily $\omega$-categorical.

\subsection{Notation}
We use letters in italic for underlying sets of clones, algebras, and relational
structures that are denoted by the same letters. That means the symbol $A$ is
used to denote an~underlying set of: an algebra $\al A$, a~clone $\clo A$, and
a~relational structure $\rel A$. We will keep this consistent, i.e., if we
denote two structures (algebraic and relational) by the same letter, they have
the same underlying set.
Moreover, $\clo A$ denotes the clone of polymorphisms of the relational
structure $\rel A$. We will also keep some consistence between algebras,
relational structures, and clones: all operations of an~algebra $\al A$ will be
compatible with relations of $\rel A$ and belong to the clone $\clo A$.

We also say that an algebra $\al A$ is \emph{compatible} with a~relational
structure $\rel B$, if the above is the case, that is, they share a~universe ($A
= B$) and each operation of $\al A$ is compatible with every relation of
$\rel B$.
